// Spawn an editor on specified file.
//
package jd;
import java.io.IOException;

class Editor
   {
   public static void
   edit(String sourceFileName, int lineNumber)
      {
      // Figure out what editor to invoke.
      // Take patterns like: vi +%L   %F -- for vi editor
      //                     v  -l %L %F -- for v editor
      //                     notepad  %F -- for windows notepad editor
      //
      // And perform the following substitutions:
      //                              %F -- sourceFileName
      //                              %L -- lineNumber
      //
      String pattern = System.getProperty("editor");
      if (pattern == null)
         {
         String os = System.getProperty("os.name", "");
        
         if (os.startsWith("Windows"))
            pattern = "notepad %F";
         else if (os.startsWith("AIX"))
            pattern = "/usr/bin/X11/aixterm -e /usr/bin/vi +%L %F";
         else
            {
            Session.warn("can't find an \"editor\" system property");
            return;
            }
         }

      // perform pattern substitutions
      //
      StringBuffer command = new StringBuffer();
      for (int i = 0; i < pattern.length();)
         {
         char c = pattern.charAt(i++);
         if (c != '%')
            {
            command.append(c);
            continue;
            }
         c = pattern.charAt(i++);
         if (c == 'F')
            {
            command.append(sourceFileName);
            continue;
            }
         if (c == 'L')
            {
            command.append(lineNumber);
            continue;
            }
         command.append('%');
         command.append(c);
         }

      // run the command
      //
      try 
         {
         Session.warn("running " + command);
         Runtime.getRuntime().exec(command.toString());
         }
         
      catch (IOException e)
         {
         Session.popup("edit: " + e);
         }
      }
   }
