// Snapshot of threads currently running in remote debugger.
// 11 Mar 1996 Derek Lieber
//
package jd;
import  ui.*;
import  sun.tools.debug.*;
import  util.Tracer;

class ThreadsSnapshot extends Snapshot
   {
   private RemoteThread remoteThreads[]; // threads to be displayed
   
   // This snapshot's currently selected thread (null --> no selection).
   //
   synchronized
   RemoteThread
   currentSelection()
      {
      return selectedLino == -1 ? null : remoteThreads[selectedLino];
      }
   
   // Create snapshot of threads running in remote debugger,
   // with specified thread (if present) as "currentSelection".
   // Runs in "Debugger" thread.
   //
   ThreadsSnapshot(RemoteThread fullList[], RemoteThread initialSelection)
      throws Exception
      {
   // Tracer.trace("genText", "threads");
   
      remoteThreads = fullList;
      selectedLino  = -1;
      StringBuffer buf = new StringBuffer();
      for (int i = 0, n = remoteThreads.length; i < n; ++i)
         {
         RemoteThread thread = remoteThreads[i];
         if (thread == initialSelection)
            selectedLino = i;
         buf.append(" " + thread.getName() + " (" + thread.getStatus() + ")\n");
         }
      text = buf.toString();
      }
      
   // Create a copy of "oldSnapshot", but with new selection at specified line.
   //
   ThreadsSnapshot(ThreadsSnapshot oldSnapshot, int lino)
      throws Exception
      {
      text          = oldSnapshot.text;
      selectedLino  = lino;
      remoteThreads = oldSnapshot.remoteThreads;
      }

   // Load scroller with latest text and markup, just prior to painting screen.
   // Runs in "AWT" thread.
   //
   synchronized
   void 
   update(TextScroller body, Snapshot previousSnapshot) //- extends Snapshot
      {
      super.update(body, previousSnapshot);
      for (int i = 0, n = remoteThreads.length; i < n; ++i)
         {
         RemoteThread thread = remoteThreads[i];
         body.setDecoratedLine(i, thread.isSuspended() ? DebuggerFrame.redLightImage : DebuggerFrame.greenLightImage);
         }
      }
   }
