// Window for displaying "flyover help" strings.
//
package ui;
import java.awt.*;

public
class FlyoverWindow extends Window
   {
   String message = "";
   
   //-----------//
   // interface //
   //-----------//
   
   // Create message, initially hidden.
   //
   public
   FlyoverWindow(Frame frame)
      {
      super(frame);
      setLayout(null);
      setBackground(Color.yellow);
      }

   // Reveal message.
   // x = place to put center of message box.
   // y = place to put lower edge of message box.
   //
   synchronized
   public void
   on(String message, int screenX, int screenY)
      {
///   this.message = " " + message + " ";
///   pack();
///   setLocation(screenX - getSize().width / 2, screenY - getSize().height);
///   setVisible(true);
   
      this.message = " " + message + " ";
      setSize(100, 100); // dummy initial size, for AIX and Solaris, otherwise window isn't shown
      pack();            // now resize to fit text
      setLocation(screenX - getSize().width / 2, screenY - getSize().height); // now set position
      setVisible(true);  // finally, display window
      }
      
   // Hide message.
   //
   synchronized
   public void
   off()
      {
      setVisible(false);
      }

   //------------------------//
   // implementation details //
   //------------------------//

   synchronized
   public Dimension
   getPreferredSize() //- overrides Component
      {
      Graphics    g = getGraphics();
      FontMetrics m = g.getFontMetrics();
      Dimension   d = new Dimension(m.stringWidth(message), m.getHeight() + 2);
      g.dispose();
      return d;
      }
      
   synchronized
   public Dimension
   getMinimumSize() //- overrides Component
      {
      return getPreferredSize();
      }
      
   synchronized
   public Dimension
   getMaximumSize() //- overrides Component
      {
      return getPreferredSize();
      }
      
   synchronized
   public void
   paint(Graphics g) //- overrides Container
      {
      int x = 0;
      int y = g.getFontMetrics().getMaxAscent();
      g.drawString(message, x, y);
      g.drawRect(0, 0, getSize().width - 1, getSize().height - 1);
      }
   }
